/* Autogenerated file. Do not edit manually. */
/* tslint:disable */
/* eslint-disable */

import BN from "bn.js";
import { ContractOptions } from "web3-eth-contract";
import { EventLog } from "web3-core";
import { EventEmitter } from "events";
import {
  Callback,
  PayableTransactionObject,
  NonPayableTransactionObject,
  BlockType,
  ContractEventLog,
  BaseContract,
} from "./types";

interface EventOptions {
  filter?: object;
  fromBlock?: BlockType;
  topics?: string[];
}

export type PauserAdded = ContractEventLog<{
  account: string;
  0: string;
}>;
export type PauserRemoved = ContractEventLog<{
  account: string;
  0: string;
}>;

export interface PauserRole extends BaseContract {
  constructor(
    jsonInterface: any[],
    address?: string,
    options?: ContractOptions
  ): PauserRole;
  clone(): PauserRole;
  methods: {
    isPauser(account: string): NonPayableTransactionObject<boolean>;

    addPauser(account: string): NonPayableTransactionObject<void>;

    renouncePauser(): NonPayableTransactionObject<void>;
  };
  events: {
    PauserAdded(cb?: Callback<PauserAdded>): EventEmitter;
    PauserAdded(
      options?: EventOptions,
      cb?: Callback<PauserAdded>
    ): EventEmitter;

    PauserRemoved(cb?: Callback<PauserRemoved>): EventEmitter;
    PauserRemoved(
      options?: EventOptions,
      cb?: Callback<PauserRemoved>
    ): EventEmitter;

    allEvents(options?: EventOptions, cb?: Callback<EventLog>): EventEmitter;
  };

  once(event: "PauserAdded", cb: Callback<PauserAdded>): void;
  once(
    event: "PauserAdded",
    options: EventOptions,
    cb: Callback<PauserAdded>
  ): void;

  once(event: "PauserRemoved", cb: Callback<PauserRemoved>): void;
  once(
    event: "PauserRemoved",
    options: EventOptions,
    cb: Callback<PauserRemoved>
  ): void;
}
